<template>
  <div>
    <b>{{ title }}:</b>
    <span
      style="font-size: 0.8rem"
      v-if="selected.day && selected.month && selected.year && selected.hour && selected.minute"
      class="pl-1"
    >
      Data válida
      <v-icon class="pl-0 mb-0" color="green" small>mdi-check</v-icon>
    </span>
    <div style="display: flex; flex-wrap: wrap;" class="mt-4">
      <v-icon class="pb-6 pr-1">{{ icon }}</v-icon>
      <v-select
        v-model="selected.month"
        :items="month"
        item-text="label"
        label="Mês"
        dense
        outlined
        flat
        style="max-width: 140px; min-width: 140px"
        class="mr-1"
        @change="updateMonth(selected.month)"
      ></v-select>
      <v-select
        :disabled="!selected.month"
        v-model="selected.day"
        :items="days"
        label="Dia"
        dense
        outlined
        flat
        style="max-width: 80px; min-width: 80px; height: 90%"
        class="mr-1"
      ></v-select>
      <v-select
        v-model="selected.year"
        :items="year"
        label="Ano"
        dense
        outlined
        flat
        style="max-width: 100px; min-width: 100px"
        class="mr-1"
      ></v-select>
      <v-icon class="pb-6 px-1">mdi-clock-outline</v-icon>
      <v-select
        v-model="selected.hour"
        :items="hours"
        label="Hora"
        dense
        outlined
        flat
        style="max-width: 80px; min-width: 80px"
        class="mr-1"
      ></v-select>
      <v-select
        v-model="selected.minute"
        :items="minutes"
        label="Min"
        dense
        outlined
        flat
        style="max-width: 80px;min-width: 80px"
        class="mr-1"
      ></v-select>
      <v-tooltip
        :disabled="
          !selected.day && !selected.month && !selected.year && !selected.hour && !selected.minute
        "
        color="red"
        bottom
      >
        <template v-slot:activator="{ on }">
          <v-btn
            :disabled="
              !selected.day &&
                !selected.month &&
                !selected.year &&
                !selected.hour &&
                !selected.minute
            "
            v-on="on"
            small
            fab
            text
          >
            <v-icon color="red" @click="cleanData">mdi-minus</v-icon>
          </v-btn>
        </template>
        <span><b>Limpar</b> {{ title }}</span>
      </v-tooltip>
    </div>
  </div>
</template>

<script>
export default {
  name: 'SelectData',
  props: {
    icon: { type: String, default: 'mdi-calendar' },
    title: { type: String, default: 'Data' },
    toUpdate: {
      type: Number,
    },
  },
  computed: {
    cleanDatas() {
      return this.$store.state.user.cleanAdvancedCollaborativeWork
    },
  },
  data: () => ({
    selected: { day: '', month: '', year: '', hour: '', minute: '' },
    days: [],
    month: [
      { label: 'Janeiro', days: 31, value: '01' },
      { label: 'Fevereiro', days: 28, value: '02' },
      { label: 'Março', days: 31, value: '03' },
      { label: 'Abril', days: 30, value: '04' },
      { label: 'Maio', days: 31, value: '05' },
      { label: 'Junho', days: 30, value: '06' },
      { label: 'Julho', days: 31, value: '07' },
      { label: 'Agosto', days: 31, value: '08' },
      { label: 'Setembro', days: 30, value: '09' },
      { label: 'Outubro', days: 31, value: '10' },
      { label: 'Novembro', days: 30, value: '11' },
      { label: 'Dezembro', days: 31, value: '12' },
    ],
    year: [],
    hours: [],
    minutes: [],
  }),
  created() {
    this.updateHourMin()
    this.editDataLoad()
    this.creatingYears()
  },
  beforeUpdate() {
    if (this.selected.month == '02' && this.selected.year) {
      this.updateFebruaryDays()
      this.updateMonth('02')
    }
  },
  watch: {
    cleanDatas() {
      //limpa os dados toda vez que o cleanDatas é alterado
      this.selected = { day: '', month: '', year: '', hour: '', minute: '' }
    },
    'selected.day'() {
      this.$emit('selectedDateDone', this.selected)
    },
    'selected.month'() {
      this.$emit('selectedDateDone', this.selected)
    },
    'selected.year'() {
      this.$emit('selectedDateDone', this.selected)
    },
    'selected.hour'() {
      this.$emit('selectedDateDone', this.selected)
    },
    'selected.minute'() {
      this.$emit('selectedDateDone', this.selected)
    },
    toUpdate() {
      this.editDataLoad()
    },
  },
  methods: {
    editDataLoad() {
      if (this.toUpdate) {
        let date = new Date(this.toUpdate)
        let month = date.getMonth() + 1
        let year = date.getFullYear()
        let day = date.getDate()
        let hour = date.getHours()
        let minute = date.getMinutes()
        this.selected.month = month <= 9 ? `0${month}` : `${month}`
        this.updateMonth(this.selected.month)
        this.selected.year = year
        this.selected.day = day <= 9 ? `0${day}` : `${day}`
        this.selected.hour = hour <= 9 ? `0${hour}` : `${hour}`
        this.selected.minute = minute <= 9 ? `0${minute}` : `${minute}`
      }
    },
    cleanData() {
      this.selected = { day: '', month: '', year: '', hour: '', minute: '' }
    },
    creatingYears() {
      let data = new Date()
      let year = parseInt(data.getFullYear())
      for (let i = 0; i < 5; i++) {
        this.year.push(year + i)
      }
    },
    updateHourMin() {
      for (let i = 0; i <= 23; i++) {
        if (i <= 9) this.hours.push(`0${i}`)
        else {
          this.hours.push(`${i}`)
        }
      }
      for (let i = 0; i <= 59; i++) {
        if (i <= 9) this.minutes.push(`0${i}`)
        else {
          this.minutes.push(`${i}`)
        }
      }
    },
    updateFebruaryDays() {
      let date = new Date(this.selected.year, 2, 0)
      let februaryDays = date.getDate()
      this.month[1].days = februaryDays
    },
    updateMonth(value) {
      let days = []
      this.month.forEach((month) => {
        // alterar dias
        if (month.value == value) {
          if (this.selected.day && Number(this.selected.day) > month.days) {
            this.selected.day = `${month.days}`
          }
          for (let i = 1; i <= month.days; i++) {
            if (i <= 9) days.push(`0${i}`)
            else days.push(`${i}`)
          }
        }
      })
      this.days = days
    },
  },
}
</script>

<style></style>
